/* DOS program for displaying built-in ASCII font to screen.
   Copyright (C) 1996, 1997 Bang Jun-Young

   Permission granted to use this source for any purpose, provided
   that this copyright notice remains present and intact. */

/* TODO: Port to Linux. */

int save_mode(void);
void set_mode(unsigned short mode);

main(int argc, int *argv[])
{
    unsigned long far *font_addr = 0x0000010cL;	/* 0000:010C */
    unsigned char far *font_offset;
    unsigned segment, offset;
    int i, j;

    if (argc < 2) {
	printf("Usage: %s [OPTION]\n"
	       "  -f     Display built-in 8x16 ASCII font\n", argv[0]);
	return 1;
    }

    set_mode(0x12);
    font_offset = *font_addr;
    segment = *font_addr >> 16;
    offset = (*font_addr << 16) >> 16;
    set_mode(0x03);

    if (strcmp(argv[1], "-f")) {
	printf("%s\n\n"
               "Starting address of font currently in use is %X:%X\n\n",
	       message, segment, offset);
    } else {
	for (i = 0; i < 256; i++) 
	    for (j = 0; j < 16; j++)
		printf("%c", *(font_offset++));
    }
}

void set_mode(unsigned short mode)
{
    asm {
	mov ah, 0
	mov al, mode
	int 0x10
    }
}

int save_mode(void)
{
    /* TODO: Implement this. */
}
