/* Raw bitmap font to C source conversion program.
   Copyright (C) 1997 Bang Jun-Young 
   
   Permission granted to use this source for any purpose, provided
   that this copyright notice remains present and intact.  */

#include <stdio.h>
#include <stdlib.h>

main(int argc, char *argv[])
{
    FILE *fp;
    char *file;
    int ch;
    int indent = 0;
    int i = 0, j;
    
    if (argc < 2) {
        printf("Usage: %s [indent] fontfile\n", argv[0]);
        exit(1);
    } else if (argc == 3) {
        indent = atoi(argv[1]);
        file = argv[2];
    } else
        file = argv[1];
    
    if (!(fp = fopen(file, "r"))) {
        printf("%s: Can't reading %s\n", argv[0], argv[1]);
        exit(1);
    }

    printf("const unsigned char %s[][] = {\n", file);
    while ((ch = getc(fp)) != EOF) {
        if (i == 0)
            for (j = 0; j < indent; j++)
                printf(" ");
        printf("%3d,", ch);
        i++;
        if (i == 16) {
            printf("\n");
            i = 0;
        }
    }
    printf("};\n");
    fclose(fp);
}
