/* Program that generates Unicode Hangul syllable data.
   Copyright (C) 2000 Bang Jun-Young

   Permission is granted to use this source for any purpose, provided
   that this copyright notice remains present and intact. */

   
#define UNICODE_HANGUL_FIRST 	0xac00
#define UNICODE_HANGUL_LAST	0xd7a3

#define NUM_CHOSEONG		19
#define NUM_JOONGSEONG		21
#define NUM_JONGSEONG		28

main()
{
	int a, b;
	int choseong, joongseong, jongseong;

	char *cho[NUM_CHOSEONG] = {
		"G", "GG", "N", "D", "DD", "R", "M", "B", "BB", "S", 
		"SS", "", "J", "JJ", "C", "K", "T", "P", "H"
	};

	char *joong[NUM_JOONGSEONG] = {
		"A", "AE", "YA", "YAE", "EO", "E", "YEO", "YE", "O", "WA",
		"WAE", "OE", "YO", "U", "WEO", "WE", "WI", "YU", "EU", "YI", 
		"I"
	};

	char *jong[NUM_JONGSEONG] = {
		"", "G", "GG", "GS", "N", "NJ", "NH", "D", "L", "LG", 
		"LM", "LB", "LS", "LT", "LP", "LH", "M", "B", "BS", "S",
		"SS", "NG", "J", "C", "K", "T", "P", "H"
	};

	printf("Total Hangul syllables = %d\n\n", 
		UNICODE_HANGUL_LAST - UNICODE_HANGUL_FIRST + 1);

	for (a = UNICODE_HANGUL_FIRST; a <= UNICODE_HANGUL_LAST; a++) {
		b = a - UNICODE_HANGUL_FIRST;
		choseong = b / (NUM_JOONGSEONG * NUM_JONGSEONG);
		joongseong = (b % (NUM_JOONGSEONG * NUM_JONGSEONG)) / NUM_JONGSEONG;
		jongseong = b % NUM_JONGSEONG;

		printf("U+%04X (%05d)  %s %s %s\n", a, b, 
			cho[choseong], joong[joongseong], jong[jongseong]);
	}
}

