/* Quick-and-dirty ISO-2022-KR to EUC-KR conversion program. 
   Copyright (C) 1997 Bang Jun-Young

   Permission granted to use this source for any purpose, provided 
   that this copyright notice remains present and intact.  */

#include <stdio.h>

/* shift-out and shift-in stand for 
   start and end of Hangul, respectively.  */
#define SO	0x0e
#define SI	0x0f
#define ESC	0x1b
#define SPACE	0x20

main(int argc, char *argv[])
{
    FILE *fp;
    short ch;
    unsigned char han_flag;
    int i;

    if (argc < 2) {
	fprintf(stderr, "Usage: %s filename\n", argv[0]);
	exit(1);
    }

    fp = fopen(argv[1], "r");
    if (!fp) {
	fprintf(stderr, "%s: Can't read file %s\n", argv[0], argv[1]);
	exit(1);
    }

    while ((ch = getc(fp)) != EOF) {
	switch (ch) {
	case ESC:
	    /* XXX Ignore escape sequence, but shouldn't do.  */
	    for (i = 0; i < 3; i++)
	        ch = getc(fp);
	    break;
	case SO:
            han_flag = 1;
	    break;
        case SI:
            han_flag = 0;
            break;
        case SPACE:
            printf("%c", ch);
	    break;
        default: 
	    printf("%c", (han_flag ? (ch + 128) : ch));
        }
    }    
}
